      program match_motif 
c
c  program to find a match between interaction motifs on a given complex
c  and a data base of interaction motifs (based on consecutive 4 CA atoms on each partner)
c
      character*80 name1,name2,name3,name4,filnam,b
      character*4 tt(3000000),rg(3000000),label(2000)
      character*4 at,ttt(5000),rrg(5000),atyp(20),ttn(5000),rrn(5000)
      integer re(3000000),ka(3000000),iai(500000),kaa(5000),ree(5000)
      integer ren(5000),kan(5000)
      integer nij(51000),jmax(0:51000),kset(500,25,4),iaj(2500)
      integer ksa(250000,4),ksb(250000,4),ksaa(250000,4),ksbb(250000,4)
      integer ipo_at(0:2000),ipo_ca(0:2000),ipo_mo(0:2000)
      integer ncatm(2000),natm(2000),ispl(2000),nmot(2000)
      integer mat(2500000),max(2500000),nr(99999),nl(99999)
      integer ima(5000,20),lotm(5000),jtyp(20),nop(5),noq(5),ncom(2500)
      real x(3000000),y(3000000),z(3000000)
      real xx(25000),yy(25000),zz(25000),sas(25000)
      real xxn(25000),yyn(25000),zzn(25000)
      real dis(4),dset(500,25,3),dta(99999,3),dtb(99999,3),dit(99999,17)
      real da(250000,3),db(250000,3),di(250000,17),xa(8,3),xb(8,3)
      real xc(8,3),xn(5000,3),dn(3),dm(3),u(3,3),xop(5),yop(5),zop(5)
      real xoq(5),yoq(5),zoq(5),xcom(2500),ycom(2500),zcom(2500)
      real ur(5000,3,3),dnr(5000,3),dmr(5000,3),dtot(5),dtoq(5)      
c atyp(): Amino acids ordered polar->nonpolar
      data (atyp(j),j=1,20)/'ASP ','GLU ','LYS ','ARG ','HIS ','ASN ',
     1 'GLN ','SER ','THR ','CYS ','ALA ','VAL ','ILE ','LEU ','MET ',
     2 'TYR ','TRP ','PHE ','GLY ','PRO '/
c jtyp(): Number of atoms beyond CA
c in the pdb-files the atoms must be ordered like: N CA C O side chain N CA C O ..
      data (jtyp(j),j=1,20)/6,7,7,9,8,6,7,4,5,4,3,5,6,6,6,10,12,9,2,5/
c  
c run the program by typing:
c   ./match_motif target.pdb motif_data.dat 10.0 1.0  
c
c  target.pdb must contain two proteins separated by "TER "
c the interface corresponds to atoms within 10.0 A of the partner
c the 1.0 indicates the maximum RMSD deviation of a motif at the
c interface in X.pdb from a corresponding motif in the motif-data file:
c motif_data.dat
c
      call getarg(1,name1)
      call getarg(2,name2)
      call getarg(3,name3)
      call getarg(4,name4)
c name1 ist die input receptor-ligand pdb-structure
      open(43,file=name1,status='old')
c name2 is the input data base for motifs
      open(44,file=name2,status='old')
c xlimit is the distance threshold for motif on receptor vs. ligand
      read(name3,*) xlimit
      xlimit=xlimit**2
c ylimit the upper distance limit for a match
      read(name4,*) ylimit
      ylimit=ylimit**2 
      i=1
      k=1
      iatom=0
c this part reads the target.pdb file
   40 read(43,20,end=35) b
      if(b(:3).eq.'TER'.and.iatom.eq.1) then
      isplit=k-1
      iatom=2
c     write(*,*)'TER found',isplit,iatom
      endif
      if(b(:4).eq.'ATOM') then
      if(iatom < 1) iatom=1
      read(b,26) at,kaa(i),ttt(i),rrg(i),ree(i),xx(i),yy(i),zz(i)
      if(ttt(i).eq."CA  ") then
      iaj(k)=i
      k=k+1
      endif
      i=i+1
      endif 
      goto 40
   35 close(43)
      nca=k-1
      natom=i-1
      write(*,*) 'Number of atoms target',natom 
      write(*,*) 'Number of CA-atoms in target',nca
      write(*,*) 'Number of CA in first structure',isplit
c calculate center-of-geometry of all side chain atoms and CA of all residues
      do i=1,nca
       xcom(i)=0.0
       ycom(i)=0.0
       zcom(i)=0.0
       ncom(i)=0
      enddo
      ir=1
      iold=ree(1)
      do i=1,natom
      if(ree(i).ne.iold) then
      xcom(ir)=xcom(ir)/ncom(ir)
      ycom(ir)=ycom(ir)/ncom(ir)
      zcom(ir)=zcom(ir)/ncom(ir)
      iold=ree(i)
      ir=ir+1
      endif
      if(ttt(i).ne."C   ".and.ttt(i).ne."O   ".and.ttt(i).ne."N   ")
     1 then
      xcom(ir)=xcom(ir)+xx(i)
      ycom(ir)=ycom(ir)+yy(i)
      zcom(ir)=zcom(ir)+zz(i)
      ncom(ir)=ncom(ir)+1
      endif
      enddo
      xcom(ir)=xcom(ir)/ncom(ir)
      ycom(ir)=ycom(ir)/ncom(ir)
      zcom(ir)=zcom(ir)/ncom(ir)
c     write(*,*)'nca,ir',nca,ir
c     do j=1,nca
c     i=iaj(j)
c     write(*,26) at,kaa(i),ttt(i),rrg(i),ree(i),xx(i),yy(i),zz(i)
c     write(*,26) at,i,'COM ',rrg(i),ree(i),xcom(j),ycom(j),zcom(j)
c     enddo
c  read the database: motif_data.dat
c  index i indicates the structure 
      i=0
c  index l für motif
      l=0
c  index j für atom
      j=1
c  index k für ca-atom
      k=1
   50 read(44,20,end=55) b
      if(b(:3).eq.'pdb') then
       i=i+1
c all structural motifs are consecutively stored in a long array (x(),y(),z())
       ipo_at(i)=j
       ipo_ca(i)=k
       ipo_mo(i)=l
      read(b,'(21x,a4,6i6)') label(i),ncatm(i),natm(i),ispl(i),nmot(i)
c     write(*,*)'label',i,label(i),ncatm(i),natm(i),ispl(i),nmot(i)
        do kk=1,nmot(i)
         l=l+1
         read(44,24) ijk,(ksa(l,m),m=1,4),(ksb(l,m),m=1,4),
     1 (da(l,m),m=1,3),(db(l,m),m=1,3),(di(l,m),m=1,17)
          do m=1,4
          ksaa(l,m)=ksa(l,m)+ipo_at(i)-1
          ksbb(l,m)=ksb(l,m)+ipo_at(i)-1
          enddo
        enddo
c set pointers
      elseif(b(:4).eq.'ATOM') then 
      read(b,26) at,ka(j),tt(j),rg(j),re(j),x(j),y(j),z(j)
        if(tt(j).eq."CA  ") then
        iai(k)=j
        k=k+1
        endif
      j=j+1
      endif 
      goto 50
   55 close(44)
c  
      na_max=j-1
      ns_max=i
      nm_max=l
      nc_max=k-1
      write(*,*)'reading of motif data file completed'
      write(*,*)'Number of Structures',ns_max 
      write(*,*)'total number of atoms',na_max
      write(*,*)'total number of CA atoms',nc_max
      write(*,*)'total number of motifs',nm_max
c
c now start matching process
c extract the motifs in the target.pdb structure
c check first if backbone pattern on both partners fits -> list
c then check in this list if the inter-distances match 
c
      call target(xx,yy,zz,dta,dtb,dit,xlimit,iaj,nr,nl,nmo,
     1 isplit,nca,natom)
c xlim, clim, slim are additional parameters for selecting the matching motifs
c nmo is the number of structural motifs identified in the target interface
      xlim=1.5
      clim=1.5
      slim=10.0
      call compare(ksaa,ksbb,da,db,di,dta,dtb,dit,mat,nr,nl,
     1 nm_max,nmo,max,motmax,xlim,clim,slim)
c
c  identify possible motifs in a given complex
c  the ima-array stores how often a residue substitution is suggested for
c  a given position in the target-structures based on the matching motifs.
c  set ima-array to zero
c
      do i=1,nca
       do j=1,20
        ima(i,j)=0
       enddo
      enddo
      ijk=0
c open files for storing matching motifs and tabelle of substitution frequencies
      open(49,file='motifs.pdb')
      do ii=1,motmax
      i=max(ii)
      l=mat(ii)
c     write(*,*)'i,l',motmax,ii,i,l
         do m=1,4
         xb(m,1)=x(ksaa(l,m))
         xb(m,2)=y(ksaa(l,m))
         xb(m,3)=z(ksaa(l,m))
         xb(m+4,1)=x(ksbb(l,m))
         xb(m+4,2)=y(ksbb(l,m))
         xb(m+4,3)=z(ksbb(l,m))
         xa(m,1)=xx(iaj(nr(i)+m-1))
         xa(m,2)=yy(iaj(nr(i)+m-1))
         xa(m,3)=zz(iaj(nr(i)+m-1))
         xa(m+4,1)=xx(iaj(nl(i)+m-1))
         xa(m+4,2)=yy(iaj(nl(i)+m-1))
         xa(m+4,3)=zz(iaj(nl(i)+m-1))
         enddo
c     write(*,*)'call superpose'
        call superpose(xa,xb,dm,dn,u,rms,8)
c       write(*,*)'rms',xb(m,1),xa(m,1),rms
        if(rms.le.ylimit) then
        ijk=ijk+1
        lotm(ijk)=ii
c store the u-matrix and the shifts      
          do m=1,3
           do n=1,3
            ur(ijk,m,n)=u(m,n)
           enddo
           dnr(ijk,m)=dn(m)
           dmr(ijk,m)=dm(m)
          enddo
        ik=1
c   check sequence and store  
        write(49,'(a6,i5,f8.3)') "MODEL ",ijk,rms
c set mean residue coordinates to zero
c set minimum distance (dtot) to CA-atoms of partner to zero
c set number of residues nop() zero
          do k=1,4
           xop(k)=0.0
           yop(k)=0.0
           zop(k)=0.0
           dtot(k)=200000.0
           nop(k)=0
          enddo
         ires=1
         irold=re(ksaa(l,1)-1)
c go through all atoms of first residue (-1: N-atom) to last residue (CA) +12 atoms
         do k=ksaa(l,1)-1,ksaa(l,4)+13
c        write(*,*)'re(k)',k,re(k),irold,ires
          if(re(k).ne.irold.and.ires.le.4) then
          irold=re(k)
          xop(ires)=xop(ires)/nop(ires)
          yop(ires)=yop(ires)/nop(ires)
          zop(ires)=zop(ires)/nop(ires)
c         write(*,*)'ires,xop',ires,xop(ires),yop(ires),zop(ires) 
c  check distance of residue centers from residue coms of other protein
            do ij=isplit+1,nca
      dg=(xcom(ij)-xop(ires))**2+
     1   (ycom(ij)-yop(ires))**2+
     2   (zcom(ij)-zop(ires))**2
             if(dg.lt.dtot(ires)) dtot(ires)=dg
            enddo
           ires=ires+1
          endif
         if(ires.le.4) then
          do m=1,3
        xn(ik,m)= dm(m)+
     1 u(m,1)*(x(k)-dn(1))+u(m,2)*(y(k)-dn(2))+u(m,3)*(z(k)-dn(3))
          enddo
        write(49,26)at,ka(k),tt(k),rg(k),re(k),
     1 xn(ik,1),xn(ik,2),xn(ik,3)
         if(tt(k).ne."C   ".and.tt(k).ne."O   ".and.tt(k).ne."N   ")
     1 then
         xop(ires)=xop(ires)+xn(ik,1)
         yop(ires)=yop(ires)+xn(ik,2)
         zop(ires)=zop(ires)+xn(ik,3)
         nop(ires)=nop(ires)+1
       endif
c        write(*,*)'xop',ires,xop(ires),yop(ires),zop(ires)
         endif
        enddo
      write(49,'(a4)')"TER "
          do k=1,4
           xoq(k)=0.0
           yoq(k)=0.0
           zoq(k)=0.0
           dtoq(k)=200000.0
           noq(k)=0
          enddo
         ires=1
         irold=re(ksbb(l,1)-1)
      do k=ksbb(l,1)-1,ksbb(l,4)+13
          if(re(k).ne.irold.and.ires.le.4) then
          irold=re(k)
          xoq(ires)=xoq(ires)/noq(ires)
          yoq(ires)=yoq(ires)/noq(ires)
          zoq(ires)=zoq(ires)/noq(ires)
c  check distance of residue centers from residue coms of other protein
            do ij=1,isplit
      dg=(xcom(ij)-xoq(ires))**2+
     1   (ycom(ij)-yoq(ires))**2+
     2   (zcom(ij)-zoq(ires))**2
             if(dg.lt.dtoq(ires)) dtoq(ires)=dg
            enddo
           ires=ires+1
          endif
        if(ires.le.4) then
          do m=1,3
      xn(ik,m)= dm(m)+
     1 u(m,1)*(x(k)-dn(1))+u(m,2)*(y(k)-dn(2))+u(m,3)*(z(k)-dn(3))
          enddo
      write(49,26)at,ka(k),tt(k),rg(k),re(k),
     1 xn(ik,1),xn(ik,2),xn(ik,3)
      if(tt(k).ne."C   ".and.tt(k).ne."O   ".and.tt(k).ne."N   ")
     1 then
         xoq(ires)=xoq(ires)+xn(ik,1)
         yoq(ires)=yoq(ires)+xn(ik,2)
         zoq(ires)=zoq(ires)+xn(ik,3)
         noq(ires)=noq(ires)+1
       endif
        endif
       enddo
      write(49,'(a6)')"ENDMDL"
c now calculate minimum distance between residue coms in one motif
       dmin=20000.0
        do m=1,4
         do n=1,4
         dg=(xop(m)-xoq(n))**2+(yop(m)-yoq(n))**2+(zop(m)-zoq(n))**2
         if(dg.lt.dmin) then
         dmin=dg
         ifirst=m
         iseco=n
         endif
         enddo
        enddo
c        write(*,*)'distr',dtot(1),dtot(2),dtot(3),dtot(4)
c        write(*,*)'dmin',ifirst,iseco,dmin
         do m=1,4
         ipos=nr(i)+m-1
         kpos=ksaa(l,m)
c        write(*,*)'m,ipos,kpos',
c    1   m,ipos,kpos,rg(kpos)
         do j=1,20
         if(atyp(j).eq.rg(kpos).and.dtot(m).gt.16.0.and.m.eq.ifirst) 
c          if(atyp(j).eq.rg(kpos))
     1     ima(ipos,j)=ima(ipos,j)+1
         enddo
        enddo
c      write(*,*)'distl',dtoq(1),dtoq(2),dtoq(3),dtoq(4),ires
       do m=1,4
         ipot=nl(i)+m-1
         kpot=ksbb(l,m)
c        write(*,*)'m,ipot,kpos',
c    1   m,ipot,kpot,rg(kpot)
         do j=1,20
          if(atyp(j).eq.rg(kpot).and.dtoq(m).gt.16.0.and.m.eq.iseco)
c         if(atyp(j).eq.rg(kpot)) 
     1    ima(ipot,j)=ima(ipot,j)+1
         enddo
        enddo
      endif
      enddo
      ijkmax=ijk
      write(*,*)'Number of matching motifs',ijkmax
      open(48,file='residues.dat')
      write(48,*)'Number of matching motifs',ijkmax
      write(48,'(21x,20a4)')(atyp(m),m=1,20)
      do i=1,nca
      write(48,'(a11,i5,a4,20i4)')'resid count',
     1 i,rrg(iaj(i)),(ima(i,m),m=1,20)
      enddo
      close(48)
c   
c  now output a complex structure with the interface residues replaced by the most
c  frequently found residues at the corresponding positions in the matching motifs
c  write into separate file:
      open(51,file='result.pdb')
c  receptor part
      it=0
      do ii=1,isplit
       mold=0
       mmax=0
       do m=1,20
        if(ima(ii,m).gt.mmax) then
        mold=m
        mmax=ima(ii,m)
        endif
       enddo
        if(mold.gt.0.and.mmax.gt.0) then
c check motif that contains the new residue
c        write(51,*)'insert',ii,mold,mmax,it
         iflag=0        
         do j=1,ijkmax
            jj=lotm(j)
            i=max(jj)
            l=mat(jj)
             do m=1,4
              ipos=nr(i)+m-1
              kpos=ksaa(l,m)
         if(ii.eq.ipos.and.atyp(mold).eq.rg(kpos).and.iflag.eq.0) then
c         write(51,*)'accept',ii,jj,i,l,nr(i),m
              if(m.lt.4) then
              iup=ksaa(l,m+1)-2
              else
              iup=ksaa(l,m)+jtyp(mold)
              endif
              do k=ksaa(l,m)-1,iup
              it=it+1
              kan(it)=it
              ttn(it)=tt(k)
              rrn(it)=rg(k)
              ren(it)=ree(iaj(ii))
              xxn(it)=ur(j,1,1)*(x(k)-dnr(j,1))+
     1 ur(j,1,2)*(y(k)-dnr(j,2))+ur(j,1,3)*(z(k)-dnr(j,3))+dmr(j,1)
              yyn(it)=ur(j,2,1)*(x(k)-dnr(j,1))+
     1 ur(j,2,2)*(y(k)-dnr(j,2))+ur(j,2,3)*(z(k)-dnr(j,3))+dmr(j,2)
              zzn(it)=ur(j,3,1)*(x(k)-dnr(j,1))+
     1 ur(j,3,2)*(y(k)-dnr(j,2))+ur(j,3,3)*(z(k)-dnr(j,3))+dmr(j,3)
              enddo
              iflag=1
              endif
             enddo
          enddo
        else
c         write(51,*)'no insert',ii,mold,mmax,it
          do k=iaj(ii)-1,iaj(ii+1)-2
              it=it+1
              kan(it)=it
              ttn(it)=ttt(k)
              rrn(it)=rrg(k)
              ren(it)=ree(k)
              xxn(it)=xx(k)
              yyn(it)=yy(k)
              zzn(it)=zz(k)
          enddo
        endif
       enddo
      itsplit=it
c  ligand part
      do ii=isplit+1,nca-1
       mold=0
       mmax=0
       do m=1,20
        if(ima(ii,m).gt.mmax) then
        mold=m
        mmax=ima(ii,m)
        endif
       enddo
        if(mold.gt.0.and.mmax.gt.0) then
c check motif that contains the new residue
         iflag=0        
         do j=1,ijkmax
            jj=lotm(j)
            i=max(jj)
            l=mat(jj)
             do m=1,4
              ipot=nl(i)+m-1
              kpot=ksbb(l,m)
         if(ii.eq.ipot.and.atyp(mold).eq.rg(kpot).and.iflag.eq.0) then
              if(m.lt.4) then
              iup=ksbb(l,m+1)-2
              else
              iup=ksbb(l,m)+jtyp(mold)
              endif
              do k=ksbb(l,m)-1,iup
              it=it+1
              kan(it)=it
              ttn(it)=tt(k)
              rrn(it)=rg(k)
              ren(it)=ree(iaj(ii))
              xxn(it)=ur(j,1,1)*(x(k)-dnr(j,1))+
     1 ur(j,1,2)*(y(k)-dnr(j,2))+ur(j,1,3)*(z(k)-dnr(j,3))+dmr(j,1)
              yyn(it)=ur(j,2,1)*(x(k)-dnr(j,1))+
     1 ur(j,2,2)*(y(k)-dnr(j,2))+ur(j,2,3)*(z(k)-dnr(j,3))+dmr(j,2)
              zzn(it)=ur(j,3,1)*(x(k)-dnr(j,1))+
     1 ur(j,3,2)*(y(k)-dnr(j,2))+ur(j,3,3)*(z(k)-dnr(j,3))+dmr(j,3)
              enddo
              iflag=1
              endif
             enddo
          enddo
        else
          do k=iaj(ii)-1,iaj(ii+1)-2
              it=it+1
              kan(it)=it
              ttn(it)=ttt(k)
              rrn(it)=rrg(k)
              ren(it)=ree(k)
              xxn(it)=xx(k)
              yyn(it)=yy(k)
              zzn(it)=zz(k)
          enddo
        endif
       enddo
       itmax=it      
c output of modified complex
      ichr=0
      ichl=0
      icaa=0
      write(*,*)'substitutions in target with alternative interface'
      do i=1,itsplit
      write(51,27) at,kan(i),ttn(i),rrn(i),"A",ren(i),
     1 xxn(i),yyn(i),zzn(i)
      if(ttn(i).eq."CA  ") icaa=icaa+1
      if(ttn(i).eq."CA  ".and.rrn(i).ne.rrg(iaj(icaa))) then
      write(*,*)'substitution',i,icaa,rrn(i),rrg(iaj(icaa))
      ichr=ichr+1
      endif
      enddo
      write(51,'(a4)')'TER '
      do i=itsplit+1,itmax
      write(51,27) at,kan(i),ttn(i),rrn(i),"B",ren(i),
     1 xxn(i),yyn(i),zzn(i)
      if(ttn(i).eq."CA  ") icaa=icaa+1
      if(ttn(i).eq."CA  ".and.rrn(i).ne.rrg(iaj(icaa))) then
      write(*,*)'substitution',i,icaa,rrn(i),rrg(iaj(icaa))
      ichl=ichl+1
      endif
      enddo 
      write(*,*)'changes in first protein',ichr 
      write(*,*)'changes in second protein',ichl
      close(49)
      close(51)
   23 format(a4,3i4,3f6.2,8i5)
   24 format(i3,8i5,23f6.2)
   29 format(i3,8i6,23f6.2)
   20 format(a80)
   25 format(a4,i7,1x,a4,1x,a4,i5,4x,3f8.3)
   26 format(a4,i7,2x,a4,a4,1x,i4,4x,3f8.3)
   27 format(a4,i7,2x,a4,a4,a1,i4,4x,3f8.3)
 2000 end
c
      subroutine target(xx,yy,zz,dta,dtb,dit,xlimit,iaj,nr,nl,nmo,
     1 isplit,nca,natom)
      dimension xx(natom),yy(natom),zz(natom)
      dimension dta(99999,3),dtb(99999,3),dit(99999,17)
      dimension iaj(nca),nr(99999),nl(99999)
      integer nmo,isplit,nca,natom
c generate neighbor list of CA atoms
      ilj=0
c     write(*,*)'sub',nmo,isplit,nca,natom
      do j=1,nca
      i=iaj(j)
c     write(*,'(3f8.3)') xx(i),yy(i),zz(i)
      enddo
      do ir=1,isplit-3
c calculate com of 4 CA atoms in receptor
      xcomr=0.0
      ycomr=0.0
      zcomr=0.0
      icher=0
      do i=ir,ir+3
      ii=iaj(i)
      xcomr=xcomr+xx(ii)
      ycomr=ycomr+yy(ii)
      zcomr=zcomr+zz(ii)
      if(i.gt.ir) then
      kk=iaj(i-1)
      dd=(xx(ii)-xx(kk))**2+(yy(ii)-yy(kk))**2+(zz(ii)-zz(kk))**2
c     write(*,*)'dd',ir,i,dd
      if(dd.lt.12.0.or.dd.gt.16.0) icher=1
      endif
      enddo
      xcomr=0.25*xcomr
      ycomr=0.25*ycomr
      zcomr=0.25*zcomr
      do jl=isplit+1,nca-3
c calculate com of 4 CA atoms in ligand
      xcoml=0.0
      ycoml=0.0
      zcoml=0.0
      ichel=0
      do j=jl,jl+3
      jj=iaj(j)
      xcoml=xcoml+xx(jj)
      ycoml=ycoml+yy(jj)
      zcoml=zcoml+zz(jj)
      if(j.gt.jl) then
      kk=iaj(j-1)
      dd=(xx(jj)-xx(kk))**2+(yy(jj)-yy(kk))**2+(zz(jj)-zz(kk))**2
      if(dd.lt.13.0.or.dd.gt.16.0) ichel=1
      endif
      enddo
      xcoml=0.25*xcoml
      ycoml=0.25*ycoml
      zcoml=0.25*zcoml
      di=(xcomr-xcoml)**2+(ycomr-ycoml)**2+(zcomr-zcoml)**2
c     write(*,*)'di',i,j,di,xlimit,ichel,icher
      if(di.lt.xlimit.and.ichel.eq.0.and.icher.eq.0) then
      ilj=ilj+1
      nr(ilj)=ir
      nl(ilj)=jl
      dit(ilj,17)=sqrt(di)
      endif
      enddo
      enddo
      nmo=ilj
c     write(*,*)'nmo',nmo
c    recover 3 relevant distances between CA on receptor side
      do i=1,nmo
      ilj=0
       do ik=0,1
       ii=iaj(nr(i)+ik)
        do jk=ik+2,3
        jj=iaj(nr(i)+jk)
        ilj=ilj+1
        dta(i,ilj)=sqrt((xx(ii)-xx(jj))**2+(yy(ii)-yy(jj))**2
     1+(zz(ii)-zz(jj))**2)
        enddo
       enddo
c    now on ligand side
      ilj=0
       do ik=0,1
       ii=iaj(nl(i)+ik)
        do jk=ik+2,3
        jj=iaj(nl(i)+jk)
        ilj=ilj+1
        dtb(i,ilj)=sqrt((xx(ii)-xx(jj))**2+(yy(ii)-yy(jj))**2
     1+(zz(ii)-zz(jj))**2)
      enddo
      enddo
c  loop over all pairs ends here
      enddo
      if(nmo.gt.0) then
c     write(*,'(a20,1x,a4,4i6)')'pdb Nca Natom Nmotif',
c    1 name1,nca,natom,isplit,nmo
      do i=1,nmo
      ilj=0
      do ik=0,3
      ii=iaj(nr(i)+ik)
      do jk=0,3
      jj=iaj(nl(i)+jk)
      ilj=ilj+1
      dit(i,ilj)=sqrt((xx(ii)-xx(jj))**2+(yy(ii)-yy(jj))**2
     1+(zz(ii)-zz(jj))**2)
      enddo
      enddo
c write out the motif
c     write(*,24) i,(iaj(nr(i)+k),k=0,3),(iaj(nl(i)+k),k=0,3),
c    1 (dta(i,j),j=1,3),(dtb(i,j),j=1,3),(dit(i,j),j=1,17)
c this part writes out the corresponding motif
      enddo
      endif
   24 format(i3,8i5,23f6.2)
      return 
      end
c
      subroutine compare(ksaa,ksbb,da,db,di,dta,dtb,dit,mat,nr,nl,
     1 nm_max,nmo,max,motmax,xlim,clim,slim)
      dimension ksaa(250000,4),ksbb(250000,4),nr(99999),nl(99999),
     1 mat(2500000),max(2500000)
      dimension dta(99999,3),dtb(99999,3),dit(99999,17)
      dimension da(250000,3),db(250000,3),di(250000,17)
      k=0
      do m=1,nmo
      do i=1,nm_max
      dsuma=
     1(dta(m,1)-da(i,1))**2+(dta(m,2)-da(i,2))**2+(dta(m,3)-da(i,3))**2 
        if(dsuma.lt.xlim) then
c       write(*,*)'match 1 found',i,dsuma
      dsumb=
     1(dtb(m,1)-db(i,1))**2+(dtb(m,2)-db(i,2))**2+(dtb(m,3)-db(i,3))**2 
          if(dsumb.lt.xlim) then
c       write(*,*)'match 2 found' ,i,dsuma,dsumb
            if((dit(m,17)-di(i,17))**2.lt.clim) then
c      write(*,*)'match 3 found',i,dsuma,dsumb,(dit(m,17)-di(i,17))**2
             dsumi=0.0
             do j=1,16
             dsumi=dsumi+(di(i,j)-dit(m,j))**2
             enddo
             if(dsumi.lt.slim) then
             k=k+1
c            write(*,*)'match found',m,i,k,dsuma,dsumb,dsumi
             max(k)=m
             mat(k)=i
             endif
            endif
          endif
        endif
      enddo
      enddo
      motmax=k
      return
      end
c
      subroutine superpose(xa,xb,dm,dn,u,rms,nmax)
      dimension xa(8,3),xb(8,3),xc(8,3),dn(3),dm(3),u(3,3)
      dimension xaa(8,3),xbb(8,3),a(3,3),v(3,3),w(3,3),r(3,3)
      fact=1.0d0/nmax
      do m=1,3
      dm(m)=0.
      dn(m)=0.
      enddo
      do k=1,nmax
      do m=1,3
      dm(m)=dm(m)+xa(k,m)
      dn(m)=dn(m)+xb(k,m)
      enddo
      enddo
      do m=1,3
      dm(m)=fact*dm(m)
      dn(m)=fact*dn(m)
      enddo
      do k=1,nmax
      do m=1,3
      xaa(k,m)=xa(k,m)-dm(m)
      xbb(k,m)=xb(k,m)-dn(m)
      enddo
      enddo
      do m=1,3
      do n=1,3
      a(m,n)=0.0
      do k=1,nmax
      a(m,n)=a(m,n)+xaa(k,m)*xbb(k,n)
      enddo
      enddo
      enddo
      call svdcmp(a,3,3,3,3,w,v)
      do i=1,3
      do k=1,3
      r(i,k)=v(i,1)*a(1,k)+v(i,2)*a(2,k)+v(i,3)*a(3,k)
c     r(i,k)=v(i,1)*a(k,1)+v(2,i)*a(k,2)+v(i,3)*a(k,3)
      enddo
      enddo
c determinate
      d=r(1,1)*r(2,2)*r(3,3)+r(1,2)*r(2,3)*r(3,1)+r(1,3)*r(2,1)*r(3,2)
     1-r(3,1)*r(2,2)*r(1,3)-r(3,2)*r(2,3)*r(1,1)-r(3,3)*r(2,1)*r(1,2)
c     write(*,*)'output d',d
c rotation matrix
c     write(*,*)'output rotation r'
c     do i=1,3
c     write(*,*)(r(i,j),j=1,3)
c     enddo
      do i=1,3
      do k=1,3
      u(k,i)=v(i,1)*a(k,1)+v(i,2)*a(k,2)+d*v(i,3)*a(k,3)
      enddo
      enddo
c     write(*,*)'output rotation u'
c     do i=1,3
c     write(*,*)(u(i,j),j=1,3)
c     enddo
      rms=0.
      klm=1
      do k=1,nmax
      do m=1,3
      dd=xaa(k,m)
      xc(k,m)=0.0
      do n=1,3
      xc(k,m)=xc(k,m)+u(m,n)*xbb(k,n)
      dd=dd-u(m,n)*xbb(k,n)
      enddo
      enddo
      enddo
      dd=0.0
      do k=1,nmax
      ddd=(xc(k,1)-xaa(k,1))**2
     1     +(xc(k,2)-xaa(k,2))**2
     2     +(xc(k,3)-xaa(k,3))**2
      dd=dd+ddd
      enddo
      rms=sqrt(fact*dd)
c     write(*,*) 'rms ',nmax,fact,rms
      return
      end
c
c  SVDcmp subroutine
c    Given a matrix (1:m,1:n) with physical dimensions mp by np,
c    this routine computes its singular value decomposition,
c    A = U W VT.  The matrix U replaces a on output.  The diagonal
c    matrix of singular values W is output as a vector w(1:n)
c    The matrix V (not the transpose VT) is the output as v(1:n,1:n) 
c
      SUBROUTINE svdcmp(a,m,n,mp,np,w,v)
      INTEGER m,mp,n,np,NMAX
      REAL a(mp,np),v(np,np),w(np)
      PARAMETER (NMAX=10000)
CU    USES pythag
      INTEGER i,its,j,jj,k,l,nm
      REAL anorm,c,f,g,h,s,scale,x,y,z,rv1(NMAX),pythag
      g=0.0
      scale=0.0
      anorm=0.0
      do 25 i=1,n
        l=i+1
        rv1(i)=scale*g
        g=0.0
        s=0.0
        scale=0.0
        if(i.le.m)then
          do 11 k=i,m
            scale=scale+abs(a(k,i))
11        continue
          if(scale.ne.0.0)then
            do 12 k=i,m
              a(k,i)=a(k,i)/scale
              s=s+a(k,i)*a(k,i)
12          continue
            f=a(i,i)
            g=-sign(sqrt(s),f)
            h=f*g-s
            a(i,i)=f-g
            do 15 j=l,n
              s=0.0
              do 13 k=i,m
                s=s+a(k,i)*a(k,j)
13            continue
              f=s/h
              do 14 k=i,m
                a(k,j)=a(k,j)+f*a(k,i)
14            continue
15          continue
            do 16 k=i,m
              a(k,i)=scale*a(k,i)
16          continue
          endif
        endif
        w(i)=scale *g
        g=0.0
        s=0.0
        scale=0.0
        if((i.le.m).and.(i.ne.n))then
          do 17 k=l,n
            scale=scale+abs(a(i,k))
17        continue
          if(scale.ne.0.0)then
            do 18 k=l,n
              a(i,k)=a(i,k)/scale
              s=s+a(i,k)*a(i,k)
18          continue
            f=a(i,l)
            g=-sign(sqrt(s),f)
            h=f*g-s
            a(i,l)=f-g
            do 19 k=l,n
              rv1(k)=a(i,k)/h
19          continue
            do 23 j=l,m
              s=0.0
              do 21 k=l,n
                s=s+a(j,k)*a(i,k)
21            continue
              do 22 k=l,n
                a(j,k)=a(j,k)+s*rv1(k)
22            continue
23          continue
            do 24 k=l,n
              a(i,k)=scale*a(i,k)
24          continue
          endif
        endif
        anorm=max(anorm,(abs(w(i))+abs(rv1(i))))
25    continue
      do 32 i=n,1,-1
        if(i.lt.n)then
          if(g.ne.0.0)then
            do 26 j=l,n
              v(j,i)=(a(i,j)/a(i,l))/g
26          continue
            do 29 j=l,n
              s=0.0
              do 27 k=l,n
                s=s+a(i,k)*v(k,j)
27            continue
              do 28 k=l,n
                v(k,j)=v(k,j)+s*v(k,i)
28            continue
29          continue
          endif
          do 31 j=l,n
            v(i,j)=0.0
            v(j,i)=0.0
31        continue
        endif
        v(i,i)=1.0
        g=rv1(i)
        l=i
32    continue
      do 39 i=min(m,n),1,-1
        l=i+1
        g=w(i)
        do 33 j=l,n
          a(i,j)=0.0
33      continue
        if(g.ne.0.0)then
          g=1.0/g
          do 36 j=l,n
            s=0.0
            do 34 k=l,m
              s=s+a(k,i)*a(k,j)
34          continue
            f=(s/a(i,i))*g
            do 35 k=i,m
              a(k,j)=a(k,j)+f*a(k,i)
35          continue
36        continue
          do 37 j=i,m
            a(j,i)=a(j,i)*g
37        continue
        else
          do 38 j= i,m
            a(j,i)=0.0
38        continue
        endif
        a(i,i)=a(i,i)+1.0
39    continue
      do 49 k=n,1,-1
        do 48 its=1,30
          do 41 l=k,1,-1
            nm=l-1
            if((abs(rv1(l))+anorm).eq.anorm)  goto 2
            if((abs(w(nm))+anorm).eq.anorm)  goto 1
41        continue
1         c=0.0
          s=1.0
          do 43 i=l,k
            f=s*rv1(i)
            rv1(i)=c*rv1(i)
            if((abs(f)+anorm).eq.anorm) goto 2
            g=w(i)
            h=pythag(f,g)
            w(i)=h
            h=1.0/h
            c= (g*h)
            s=-(f*h)
            do 42 j=1,m
              y=a(j,nm)
              z=a(j,i)
              a(j,nm)=(y*c)+(z*s)
              a(j,i)=-(y*s)+(z*c)
42          continue
43        continue
2         z=w(k)
          if(l.eq.k)then
            if(z.lt.0.0)then
              w(k)=-z
              do 44 j=1,n
                v(j,k)=-v(j,k)
44            continue
            endif
            goto 3
          endif
          if(its.eq.30) write(*,*) 'no convergence in svdcmp'
          x=w(l)
          nm=k-1
          y=w(nm)
          g=rv1(nm)
          h=rv1(k)
          f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
          g=pythag(f,1.0)
          f=((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
          c=1.0
          s=1.0
          do 47 j=l,nm
            i=j+1
            g=rv1(i)
            y=w(i)
            h=s*g
            g=c*g
            z=pythag(f,h)
            rv1(j)=z
            c=f/z
            s=h/z
            f= (x*c)+(g*s)
            g=-(x*s)+(g*c)
            h=y*s
            y=y*c
            do 45 jj=1,n
              x=v(jj,j)
              z=v(jj,i)
              v(jj,j)= (x*c)+(z*s)
              v(jj,i)=-(x*s)+(z*c)
45          continue
            z=pythag(f,h)
            w(j)=z
            if(z.ne.0.0)then
              z=1.0/z
              c=f*z
              s=h*z
            endif
            f= (c*g)+(s*y)
            x=-(s*g)+(c*y)
            do 46 jj=1,m
              y=a(jj,j)
              z=a(jj,i)
              a(jj,j)= (y*c)+(z*s)
              a(jj,i)=-(y*s)+(z*c)
46          continue
47        continue
          rv1(l)=0.0
          rv1(k)=f
          w(k)=x
48      continue
3       continue
49    continue
      return
      END
C
      FUNCTION pythag(a,b)
      REAL a,b,pythag
      REAL absa,absb
      absa=abs(a)
      absb=abs(b)
      if(absa.gt.absb)then
        pythag=absa*sqrt(1.+(absb/absa)**2)
      else
        if(absb.eq.0.)then
          pythag=0.
        else
          pythag=absb*sqrt(1.+(absa/absb)**2)
        endif
      endif
      return
      END
c
